#include <stdio.h>
#include <stdlib.h>

#define MAX_VERTICES 8
#define INF 9999999

int graph[8][8] = {
    {0, 1, 5, 1, 5, 1, 6, 1},
    {1, 0, 7, 5, 6, 1, 2, 3},
    {5, 7, 0, 5, 6, 2, 1, 2},
    {1, 5, 5, 0, 8, 5, 1, 5},
    {5, 6, 6, 8, 0, 7, 7, 7},
    {1, 1, 2, 5, 7, 0, 1, 1},
    {6, 2, 1, 1, 7, 1, 0, 2},
    {1, 3, 2, 5, 7, 1, 2, 0}
};

int visited[MAX_VERTICES];
int path[MAX_VERTICES];
int weight = INF;

void nearest_neighbor(int current, int count, int cost, int current_path[]) {
    if (count == MAX_VERTICES - 1) {
        if (graph[current][0] != 0 && cost + graph[current][0] < weight) {
            weight = cost + graph[current][0];
            for (int i = 0; i < MAX_VERTICES; i++) {
                path[i] = current_path[i];
            }
        }
        return;
    }
    
    for (int i = 0; i < MAX_VERTICES; i++) {
        if (!visited[i] && graph[current][i] != 0) {
            visited[i] = 1;
            current_path[count] = i;
            nearest_neighbor(i, count + 1, cost + graph[current][i], current_path);
            visited[i] = 0;
        }
    }
}

int main() {
    for (int i = 0; i < MAX_VERTICES; i++) {
        visited[i] = 0;
    }
    
    int current_path[MAX_VERTICES];
    visited[0] = 1;
    current_path[0] = 0;
    
    nearest_neighbor(0, 0, 0, current_path);
    
    printf("The minimum Hamiltonian cycle (according to the nearest neighbor algorithm) with the initial vertex 1:\n");
    printf("1 -> ");
    for (int i = 0; i < MAX_VERTICES-1; i++) {
        printf("%d", path[i] + 1);
        if (i < MAX_VERTICES - 1) {
            if (i < MAX_VERTICES - 2) {
                printf(" -> ");
            }
            else {
                printf(" ");
            }
        }
    }
    printf("-> 1\n");
    printf("Cycle weight: %d\n", weight);
    
    return 0;
}
